///////////////////////////////////////////////////////////////////////////////////////////////////////
// copy this file inside your game folder (work if you are using the templates)
// include breakwalls.wdl in your main game file (office.wdl if you are using the templates)
// place a gun model in your level and attach it the action named rocket_launcher
///////////////////////////////////////////////////////////////////////////////////////////////////////

var rocket_speed;

///////////////////////////////////////////////////////////////////////////////////////////////////////

define health skill30;

///////////////////////////////////////////////////////////////////////////////////////////////////////

sound explosion_wav = <explosion.wav>;
sound bricks_wav = <bricks.wav>;

///////////////////////////////////////////////////////////////////////////////////////////////////////

string rocket_mdl = <ball.mdl>;
string explosion_pcx = <explo+6.pcx>;

///////////////////////////////////////////////////////////////////////////////////////////////////////

function attach_item();
function move_rocket();
function remove_rocket();
function sprite_explosion();
function destroy_me();

///////////////////////////////////////////////////////////////////////////////////////////////////////

entity* rocket_ent; // the "real" rocket launcher
/*{
	type = <rlauncher.mdl>;
	layer = 10;
	view = camera; 
	x = 20; // x y z set he position of the entity
	y = -10; // in the 3d view
    z = -10;
}*/

////////////////////////////////////////////////////////////////////////////////////////////////////////

action pick_me_up() // attach it to your gun
{
    while (player == null) {wait (1);}
    rocket_ent = ent_create("rlauncher.mdl", player.pos, attach_item); // give the player a gun
}
	
function attach_item()
{
	proc_late();
	my.passable = on;
	my.metal = on;
	my.albedo = 0;
	while(player != null)
	{	
		vec_set(my.x, player.x);
	   	vec_set(my.pan, player.pan);
   		my.frame = player.frame;
	   	my.next_frame = player.next_frame;
          // get the vertex at the bottom of the palm in Med
        vec_for_vertex (my.skill1, player, 28);
          // get the vertex that separates the thumb and the pointer finger in Med 
        vec_for_vertex (my.skill4, player, 29); 
          // compute the vector that will be used by the sword
        vec_diff (my.skill7, my.skill4, my.skill1); 
          // rotate the sword accordingly
        vec_to_angle (my.pan, my.skill7); 
          // put the origin of the sword in the vertex that is placed at the bottom of the palm
        vec_set (my.x, my.skill1);		
   		wait(1);
	}
}
	
action rocket_launcher()
{
	//rocket_ent.passable = on;
	while (player == null) {wait (1);}
	/*while (vec_dist (player.x, my.x) > 100) 
	{	
		my.pan += 3 * time;
		wait (1);
	}*/
	//ent_remove (me);
	//rocket_ent.visible = on;
	//while (player.health > 0) // fire only if the player is alive
	while (1)
	{
		if ((key_ctrl == 1) || (mouse_left == 1))
		{	
			//vec_set (temp, rocket_ent.pos);
			//vec_for_screen (temp, camera);
			rocket_ent.x = rocket_ent.x-12;
			rocket_ent.y = rocket_ent.y-25;
			ent_create (rocket_mdl, rocket_ent.x, move_rocket);
            while ((key_ctrl == 1) || (mouse_left == 1)) {wait (1);} // disable auto fire			
		}
		wait (1);
	}
}

function move_rocket()
{
	my.skill1 = 1357;
	wait (1);
	my.enable_entity = on;
	my.enable_block = on;
	my.passable = on;
	my.event = remove_rocket;
	my.pan = camera.pan;
	my.tilt = camera.tilt;
	my.scale_x = 0.5;
	my.scale_y = 0.5;
	my.scale_z = 0.5;	
	rocket_speed.y = 0;
	rocket_speed.z = 0;
	while (my != null)
	{
		rocket_speed.x = 100;
		rocket_speed *= time;
		ent_move (rocket_speed, nullvector);
		if (vec_dist (camera.x, my.x) > 30) 
		{
			my.passable = off;
		}
		wait (1);
	}
}

function remove_rocket()
{
	wait (1);
	if (you != null) // if the rocket hits an entity
	{
		you.health -= 150; // it will try to kill it
	}
	vec_set (temp, my.pos);
	ent_create(explosion_pcx, temp, sprite_explosion); 
	ent_remove (me);
}

function sprite_explosion()
{
	wait (1);
	my.scale_x = 3;
	my.scale_y = my.scale_x;
	my.passable = on;
	my.flare = on;
	my.bright = on;
	my.ambient = 100;
	ent_playsound (my, explosion_wav, 400);
	while (my.frame < 7)
	{
		my.frame += 1 * time;
		wait (1);
	}
	my.invisible = on;
	sleep (2); // the explosion sound keeps playing for 2 more seconds
	ent_remove (me);
}

////////////////////////////////////////////////////////////////////////////

action wall_bricks
{
	my.enable_impact = on;
	my.enable_entity = on;
	my.event = destroy_me;
}

function destroy_me()
{
	if (you != null) // hit by an entity?
	{
		if (you.skill1 == 1357) // hit by a rocket?
		{
			ent_playsound (my, bricks_wav, 500); // play a sound
			sleep (0.5);
			ent_remove (me);
		}
	}
}
